#include <Wire.h>
#define DEVICE (0x53) // Device address as specified in data sheet
byte _buff[6];
char POWER_CTL = 0x2D;    //Power Control Register
char DATA_FORMAT = 0x31;
char DATAX0 = 0x32;    //X-Axis Data 0
char DATAX1 = 0x33;    //X-Axis Data 1
char DATAY0 = 0x34;    //Y-Axis Data 0
char DATAY1 = 0x35;    //Y-Axis Data 1
char DATAZ0 = 0x36;    //Z-Axis Data 0
char DATAZ1 = 0x37;    //Z-Axis Data 1
int xc = 100;
int yc;
int a=0;

void setup() {
  Wire.begin(); // join i2c bus (address optional for master)
  Serial.begin(9600); // start serial for output. Make sure you set your Serial Monitor to the same!
  //Put the ADXL345 into +/- 4G range by writing the value 0x01 to the DATA_FORMAT register.
  writeTo(DATA_FORMAT, 0x01);
  //Put the ADXL345 into Measurement Mode by writing 0x08 to the POWER_CTL register.
  writeTo(POWER_CTL, 0x08);
}

void loop() {
  uint8_t howManyBytesToRead = 6;
  readFrom( DATAX0, howManyBytesToRead, _buff); //read the acceleration data from the ADXL345
  // each axis reading comes in 10 bit resolution, ie 2 bytes. Least Significat Byte first!!
  // thus we are converting both bytes in to one int

  // Deze IF loop slaat de allereerste gemeten waarde van de coordinaten op,
  // om zo een correctie uit te voeren en in horizontale stand op 0 te beginnen.
  if (a < 1) {
    xc = (((int)_buff[1]) << 8) | _buff[0];
    yc = (((int)_buff[3]) << 8) | _buff[2];
    a = 1;
  } else {
  int x = (((int)_buff[1]) << 8) | _buff[0];
  int y = (((int)_buff[3]) << 8) | _buff[2];
  // MAP de getallen van X en Y MAX en MIN van 0 t/m 1000.
  float xval = map(x - xc, -160, 160, 0, 1000);
  float yval = map(y - yc, -150, 150, 0, 1000);
  // Deze correctie is nodig omdat de gegevens soms net
  // iets buiten het bereik kunnen komen.
  if (xval > 1000) {xval = 1000;}
  if (xval < 0) {xval = 0;}
  if (yval > 1000) {yval = 1000;}
  if (yval < 0) {yval = 0;}
  // Print de gegevens X en Y met als scheidingsteken een komma.
  // Ps. vergeet niet af te sluiten met een nieuwe lijn.
  Serial.print(xval / 1000);
  Serial.print(",");
  Serial.println(yval / 1000);
  // Lees de module uit elke 0,05 seconden.
  delay(50);
  }
}

void writeTo(byte address, byte val) {
  Wire.beginTransmission(DEVICE); // start transmission to device
  Wire.write(address); // send register address
  Wire.write(val); // send value to write
  Wire.endTransmission(); // end transmission
}
  
// Reads num bytes starting from address register on device in to _buff array
void readFrom(byte address, int num, byte _buff[]) {
  Wire.beginTransmission(DEVICE); // start transmission to device
  Wire.write(address); // sends address to read from
  Wire.endTransmission(); // end transmission
  Wire.beginTransmission(DEVICE); // start transmission to device
  Wire.requestFrom(DEVICE, num); // request 6 bytes from device
  int i = 0;
  while(Wire.available()) {// device may send less than requested (abnormal)
    _buff[i] = Wire.read(); // receive a byte
    i++;
    }
  Wire.endTransmission(); // end transmission
}
